$(document).ready(function () {

    $('#monitor-filter').change(function(){
        value = $(this).val();
        table  = "alias-table";
        if (value.length) {
            if (typeof $('#' + table + ' th').attr('style') == 'undefined') {
                $('#' + table + ' th:not(:last-child)').each(function () {
                    $(this).width($(this).width());
                });
            }
        } else {
            $('#' + table + ' th:not(:last-child)').each(function () {
                $(this).width('auto').removeAttr('style');
            });
        }

        $("#" + table + ' tbody tr:not(.search-empty)').each(function () {
            if ($(':contains("' + value + '")', this).length) {
                $(this).show();
                empty = false;
            } else {
                $(this).hide();
            }
        });
        if (empty) {
            if (!$("#" + table + ' tbody tr.search-empty').length)
                $("#" + table + ' tbody').append('<tr class="search-empty"><td colspan="' + countTableCollumns(table) + '" class="text-center">' + lang['search_results_empty_js'] + '</td></tr>');
        } else {
            $("#" + table + ' tbody tr.search-empty').remove();
        }


    });

    function isNaturalNumber(n) {
        n = n.toString();
        var n1 = Math.abs(n),
                n2 = parseInt(n, 10);
        return !isNaN(n1) && n2 === n1 && n1.toString() === n;
    }

    //page=history
    $('#history').dataTable({
        "order": [[0, "desc"]],
        "aoColumnDefs": [
            {
                "bSortable": false,
                "aTargets": [1, 2, 3, 4]
            }
        ],
        "iDisplayLength": 50
    });

    //page=check
    $('#check-type').on('change', function () {
        var url = link + '&page=check' + '&todo=' + todo + '&checkid=' + checkID + '&type=' + $(this).val();
        if (url) {
            window.location = url;
        }
        return false;
    });

    function renameNotyfications() {
        $('.notyfication-id').each(function (index) {
            $(this).attr('name', 'notyficationId' + '[' + index + ']');
        });
        $('.notyfication-name').each(function (index) {
            $(this).attr('name', 'notyficationName' + '[' + index + ']');
        });
        $('.notyfication-time').each(function (index) {
            $(this).attr('name', 'notyficationTime' + '[' + index + ']');
        });
        $('.notyfication-delay').each(function (index) {
            $(this).attr('name', 'notyficationDelay' + '[' + index + ']');
        });
        $('.notyfication-remove').on("click", function () {
            $(this).parent().parent().remove();
            renameNotyfications();
        });

    }
    renameNotyfications();

    $('#notyfication-list').on('change', function () {
        var membername = $("#notyfication-list :selected").text();
        var memberid = $(this).val();
        if (memberid !== '') {
            $('#notyfication-empty').find('p').text(membername);
            $('#notyfication-empty').find('.notyfication-id').val(memberid);
            $('#notyfication-empty').find('.notyfication-name').val(membername);
            $('#notyfication-fields').append($('#notyfication-empty').html());
            $("#notyfication-list option:first").attr('selected', 'selected');
        }
        renameNotyfications();
    });

    $("#param_threshold").focusout(function () {
        var timeout = $(this).val();
        if (!isNaturalNumber(timeout)) {
            alert('Timeout should be an integer.');
            $("#checksavebtn").attr("disabled", true);
            $(this).focus()
            return;
        }

        if (timeout < 1) {
            alert('Timeout must be between 1 and 90.');
            $("#checksavebtn").attr("disabled", true);
            $(this).focus()
            return;
        }

        if (timeout > 90) {
            alert('Timeout must be between 1 and 90.');
            $("#checksavebtn").attr("disabled", true);
            $(this).focus()
            return;
        }
        $("#checksavebtn").removeAttr("disabled");
    });

    //page=check type=CLUSTER
    $('#checks-add').on("click", function () {
        $('#check-fields').append($('#checks-empty').html());
        renameChecks();
    });

    function renameChecks(){
        $('.postfields-field').each(function (index) {
            $(this).attr('name', 'postfieldsField' + '[' + index + ']');
        });
        $('.postfields-value').each(function (index) {
            $(this).attr('name', 'postfieldsValue' + '[' + index + ']');
        });

        $('.checks-remove').on("click", function () {
            $(this).parent().parent().remove();
        });
    }



    //page=check type=HTTPPARSE
    $('#fields-add').on("click", function () {
        $('#fields-fields').append($('#fields-empty').html());
        renameFields();
    });

    function renameFields() {
        $('.fields-name').each(function (index) {
            $(this).attr('name', 'fieldsName' + '[' + index + ']');
        });

        $('.fields-min').each(function (index) {
            $(this).attr('name', 'fieldsMin' + '[' + index + ']');
        });

        $('.fields-max').each(function (index) {
            $(this).attr('name', 'fieldsMax' + '[' + index + ']');
        });

        $('.fields-remove').on("click", function () {
            $(this).parent().parent().remove();
            renameFields();
        });
    }
    renameFields();

    //page=check type=HTTPADV response headers
    $('#response-add').on("click", function () {
        $('#response-fields').append($('#response-empty').html());
        renameResponse();
    });

    function renameResponse() {
        $('.response-header').each(function (index) {
            $(this).attr('name', 'responseHeader' + '[' + index + ']');
        });

        $('.response-value').each(function (index) {
            $(this).attr('name', 'responseValue' + '[' + index + ']');
        });

        $('.response-remove').on("click", function () {
            $(this).parent().parent().remove();
            renameResponse();
        });
    }
    renameResponse();

    //page=check type=HTTPADV request headers
    $('#request-add').on("click", function () {
        $('#request-fields').append($('#request-empty').html());
        renameRequest();
    });

    function renameRequest() {
        $('.request-header').each(function (index) {
            $(this).attr('name', 'requestHeader' + '[' + index + ']');
        });

        $('.request-value').each(function (index) {
            $(this).attr('name', 'requestValue' + '[' + index + ']');
        });

        $('.request-remove').on("click", function () {
            $(this).parent().parent().remove();
            renameRequest();
        });
    }
    renameRequest();


    //page=check type=HTTPADV post block
    $('#postfields-add').on("click", function () {
        $('#postfields-fields').append($('#postfields-empty').html());
        renamePostfields();
    });

    function renamePostfields() {
        $('.postfields-field').each(function (index) {
            $(this).attr('name', 'postfieldsField' + '[' + index + ']');
        });

        $('.postfields-value').each(function (index) {
            $(this).attr('name', 'postfieldsValue' + '[' + index + ']');
        });

        $('.postfields-remove').on("click", function () {
            $(this).parent().parent().remove();
            renamePostfields();
        });
    }
    renamePostfields();

    $('#datablock-show').on("click", function () {
        $('#datablock textarea').attr('name', 'param_postdata');
        $('#fields input').attr('name', '');
        $('#datablock').show();
        $('#fields').hide();
    });

    $('#fields-show').on("click", function () {
        $('#datablock textarea').attr('name', '');
        renamePostfields();
        $('#fields').show();
        $('#datablock').hide();
    });


    //page=contact
    function renameContacts() {
        $('.contact-value').each(function (index) {
            $(this).attr('name', 'contactValue' + '[' + index + ']');
        });

        $('.contact-type').each(function (index) {
            $(this).attr('name', 'contactType' + '[' + index + ']');
        });

        $('.contact-id').each(function (index) {
            $(this).attr('name', 'contactID' + '[' + index + ']');
        });

        $('.contact-remove').on("click", function () {
            $(this).parent().parent().remove();
            renameContacts();
        });
    }
    renameContacts();

    $('#contact-add').on("click", function () {
        $('#contact-fields').append($('#contact-empty').html());
        renameContacts();
    });

    if ($("#contact-fields div").size() == 0) {
        $('#contact-fields').append($('#contact-empty').html());
    }


    //page=group
    function renameGroups() {
        $('.member-id').each(function (index) {
            $(this).attr('name', 'memberId' + '[' + index + ']');
        });
        $('.member-name').each(function (index) {
            $(this).attr('name', 'memberName' + '[' + index + ']');
        });
        $('.group-remove').on("click", function () {
            $(this).parent().parent().remove();
            renameGroups();
        });
    }
    renameGroups();


    $('#member-list').on('change', function () {
        var membername = $("#member-list :selected").text();
        var memberid = $(this).val();
        if (memberid !== '') {
            $('#group-empty').find('p').text(membername);
            $('#group-empty').find('.member-id').val(memberid);
            $('#group-empty').find('.member-name').val(membername);
            $('#group-fields').append($('#group-empty').html());
            $("#member-list option:first").attr('selected', 'selected');
        }
        renameGroups();
    });


});



var module = function ()
{
    var xhr = false;
    function sidebarToggle() {

        var moduleBody = $('.module-container');
        $(document).on("click touchstart", ".cp-sidebar-toggle", function (e) {
            e.preventDefault();
            var closed = 0;
            if (moduleBody.hasClass('sidebar-closed')) {
                moduleBody.removeClass('sidebar-closed');
            } else if (!moduleBody.hasClass('sidebar-closed')) {
                moduleBody.addClass('sidebar-closed');
                closed = 1;
            }

            if (xhr !== false)
                xhr.abort();

            xhr = $.ajax({
                type: "POST",
                url: location.href,
                data: {sidebar_cloased: closed}
            });
        });
    }

    function sidebarHeight() {
        var height = $('.module-sidebar').height();
        $('#mg-wrapper').css('min-height', height);
    }

    return {
        init: function () {
            sidebarToggle();
            sidebarHeight();
        }
    };
}();

$(function () {
    module.init();
    $('[title]').tooltip();
});

function getInfoHTML(info) {
    return '<div class="alert alert-success" role="alert">'
            + '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only"></span></button>'
            + '<p>' + info + '</p>'
            + '</div>';
}

function getErrorHTML(error) {
    return '<div class="alert alert-danger" role="alert">'
            + '<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only"></span></button>'
            + '<p>' + error + '</p>'
            + '</div>';
}

function generateRandomPassword() {
    var length = 12,
            charset = "abcdefghijklnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%^&*()",
            retVal = "";
    for (var i = 0, n = charset.length; i < length; ++i) {
        retVal += charset.charAt(Math.floor(Math.random() * n));
    }
    return retVal;
}

function calculatePWStrength($input) {
    var result = zxcvbn($input.val());
    var score = parseInt(result.score);
    var score_to_lang = ['very_weak', 'weak', 'adequate', 'pretty_good', 'excellent'];
    var score_to_color = ['#c9302c', '#d9534f', '#ec971f', '#5cb85c', '#449d44'];
    if ($input.parents('.modal').length) {
        $input.parents('.modal').first().find('#pwstrengthbox').html(validator_lang[score_to_lang[score]]).css('background-color', score_to_color[score]);
    } else {
        $input.parents('form').first().find('#pwstrengthbox').html(validator_lang[score_to_lang[score]]).css('background-color', score_to_color[score]);
    }
}

function htmlspecialchars_decode_js(text) {
    return text
            .replace(/&amp;/g, "&")
            .replace(/&lt;/g, "<")
            .replace(/&gt;/g, ">")
            .replace(/&quot;/g, '"')
            .replace(/&#039;/g, "'");
}

//==============================================================================

var is_ajax_action = false;

$.extend({
    getUrlVars: function () {
        var vars = [], hash;
        var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
        for (var i = 0; i < hashes.length; i++)
        {
            hash = hashes[i].split('=');
            vars.push(hash[0]);
            vars[hash[0]] = hash[1];
        }
        return vars;
    },
    getUrlVar: function (name) {
        return $.getUrlVars()[name];
    }
});

$(document).ready(function () {
    $(document).delegate("[data-toggle='modal']", 'click', function () {
        var $this = $(this);
        var insert = $this.data('modal-insert');
        var target = $this.data('target');
        if (typeof insert != "undefined" && typeof target != "undefined") {
            $.each(insert.split('|'), function (index, value) {
                var tab = value.split(':');
                var elements = $(tab[0], $(target));
                if (elements.length) {
                    elements.each(function () {
                        var el = $(this);
                        if (typeof el[0].value != "undefined") {
                            el.val(htmlspecialchars_decode_js(decodeURIComponent(tab[1])));
                        } else {
                            el.html(decodeURIComponent(tab[1]));
                        }
                    })
                }
            });
        }
    });
    //if ($.isFunction('selectBoxIt')) { $("#mg-wrapper select").selectBoxIt('destroy'); }
    $(document).delegate('#mg-wrapper [type="password"]', 'keyup change', function () {
        calculatePWStrength($(this));
    });

    $(document).on('keydown', function (event) {
        var x = event.which;
        if (x === 13) {
            if ($('#mg-wrapper .modal:visible').length) {
                $('#mg-wrapper .modal:visible').first().find('[data-act]').last().trigger('click');
            }
        }
    });

    $('#mg-wrapper').delegate('input', 'keydown', function (event) {
        var x = event.which;
        if (x === 13) {
            if ($(this).parents('.modal').length) {
                $(this).parents('.modal').first().find('[data-act]').last().trigger('click');
            } else {
                $(this).parents('form').first().find('[data-act]').last().trigger('click');
            }
            event.preventDefault();
            return false;
        }
    });

    if (typeof dataTable == 'function')
        $("#mg-wrapper .datatable").dataTable();

    $(document).delegate("#mg-wrapper [data-act]:not(.disabled)", 'click', function (e) {
        //if(is_ajax_action) return;
        is_ajax_action = true;
        var act_obj = $(this);
        doAction(act_obj);
    });

    $(document).delegate("[data-search]", 'keyup', function () {
        var value = $(this).val();
        var table = $(this).data('search');
        var empty = true;

        if (value.length) {
            if (typeof $('#' + table + ' th').attr('style') == 'undefined') {
                $('#' + table + ' th:not(:last-child)').each(function () {
                    $(this).width($(this).width());
                });
            }
        } else {
            $('#' + table + ' th:not(:last-child)').each(function () {
                $(this).width('auto').removeAttr('style');
            });
        }

        $("#" + table + ' tbody tr:not(.search-empty)').each(function () {
            if ($(':contains("' + value + '")', this).length) {
                $(this).show();
                empty = false;
            } else {
                $(this).hide();
            }
        });

        if (empty) {
            if (!$("#" + table + ' tbody tr.search-empty').length)
                $("#" + table + ' tbody').append('<tr class="search-empty"><td colspan="' + countTableCollumns(table) + '" class="text-center">' + lang['search_results_empty_js'] + '</td></tr>');
        } else {
            $("#" + table + ' tbody tr.search-empty').remove();
        }

    });

    $(document).delegate("[data-genpwd]", 'click', function () {
        var inputs = $(this).data('genpwd').split(",");
        var pwd = generateRandomPassword();
        $('#' + inputs[0]).val(pwd).attr('type', 'text').trigger('change');
        $('#' + inputs[1]).val(pwd).trigger('change');
        calculatePWStrength($('#' + inputs[0]));
        $('#' + inputs[0]).on('input', function () {
            $this = $(this);
            var position = $this.prop("selectionStart");
            $(this).attr('type', 'password');
            $this.get(0).setSelectionRange(position, position);
        });

    });

    $(document).delegate(':input[data-copy-to]', 'change keyup', function () {
        var value = $(this).val();
        $('#' + $(this).data('copy-to')).val(value);
    });
});

function setContainer(html) {
    $("#mg-container").html(html);
}

function getAlertTextLength($element) {
    var len = 0;
    $('p', $element).each(function () {
        len += $(this).html().length;
    });
    return len;
}

function setAlerts(error, info) {
    var element = $(error + info);

    $("#mg-error-container").html(element);
    if (error.length + info.length > 0)
        $('html,body').animate({scrollTop: $("#mg-error-container").offset().top - 20});
    setTimeout(function () {
        $(element).fadeOut('slow', function () {
            element.remove();
        });
    }, 5000 + (getAlertTextLength(element)) * 50);
}

function setModalError(error, modalobj) {
    var element = $(error);
    $("div.modal-body", modalobj).prepend(element);
    setTimeout(function () {
        $(element).fadeOut('slow', function () {
            element.remove();
        });
    }, 10000 + (getAlertTextLength(element)) * 50);
}

function appendLoader(obj) {
    obj.addClass('disabled');
    var no_span = obj.data("no-span");
    var noloader = obj.data("noloader");
    if (typeof noloader == 'undefined') {
        if (typeof no_span == 'undefined') {
            obj.html('<span>' + obj.html() + '</span>');
        } else {
            obj.html(obj.html());
        }
        obj.append(' <i class="fa fa-spinner fa-pulse"></i>');
    }
}

function removeLoader(obj) {
    $('.fa-spinner', obj).remove();
    var no_span = obj.data("no-span");
    if (typeof no_span == 'undefined') {
        obj.html(obj.children('span').first().html());
    }
    obj.removeClass('disabled');
}

function setAndOpenModal(html) {
    $("#mg-modal").html(html);
    $("#mg-modal > .modal").modal();
}

function closeModal(modalobj) {
    modalobj.modal('hide');
    modalobj.parent().modal('hide');
}

function doAction(obj) {

    var act = obj.data("act");

    var pathArray = queryToArray(location.search.substring(1));
    pathArray['act'] = act;

    var noloader = obj.data("noloader");
    if (typeof noloader == 'undefined') {
        appendLoader(obj);
    }

    var refresh = obj.data("refresh");
    if (typeof refresh != 'undefined') {
        pathArray['_refresh'] = 1;
    }

    var rawData = '';

    var modal = false;
    var modalobj = false;

    var formid = obj.data("formid");
    var with_modal = obj.data("with-modal");
    var no_validate = (typeof obj.data('no-validate') == 'undefined') ? false : true;

    if (obj.parents(".modal").length > 0) {
        modal = true;

        modalobj = obj.parents(".modal").first();

        if (typeof formid == 'undefined' || typeof with_modal != "undefined") {
            if (typeof obj.data("raw") != "undefined") {
                rawData = $(':input', modalobj).serialize();
            } else {
                pathArray = $.extend({}, pathArray, queryToArray($(':input', modalobj).serialize()));
            }

            if (!no_validate) {
                modalobj.validator('validate');
                if ($('.has-error', modalobj).length) {
                    removeLoader(obj);
                    return 0;
                }
            }
        }
        // modalobj = modalobj.parent()
    }

    if (typeof formid != 'undefined') {
        if (typeof obj.data("raw") != "undefined") {
            if (rawData.length == 0)
                rawData = $('#' + formid + ' :input').serialize();
            else
                rawData += '&' + $('#' + formid + ' :input').serialize();
        } else {
            var pathArray = $.extend({}, pathArray, queryToArray($('#' + formid + ' :input').serialize()));
        }

        if (!no_validate) {
            $form = $('#' + formid);
            $form.validator('validate');
            if ($('.has-error', $form).length) {
                removeLoader(obj);
                return 0;
            }
        }
    }

    var additional_query = obj.data("query");
    if (typeof additional_query != 'undefined' && additional_query.length > 0) {
        var pathArray = $.extend({}, pathArray, queryToArray(additional_query));
    }

    var rtable = obj.data('rtable');

    var subpage = obj.data('subpage');
    var page = obj.data('page');

    var do_not_close_the_modal = obj.data('dont-close-modal');

    if (typeof subpage != 'undefined' || typeof page != 'undefined') {
        (typeof page == 'undefined') ? 0 : pathArray['page'] = page;
        (typeof subpage == 'undefined') ? 0 : pathArray['subpage'] = subpage;
        location.search = arrayToQuery(pathArray);
    } else {
        pathArray['ajax'] = 1;
        $.ajax({
            type: "POST",
            url: location.pathname + '?ajax=1',
            data: arrayToQuery(pathArray) + '&' + rawData,
            //async: false
        })
                .done(function (ret) {
                    try {
                        var obj = $.parseJSON(ret);

                        if (obj.result == 1) {

                            if (typeof obj.action.refreshhtml != 'undefined') {
                                if (modal) {
                                    //closeModal(modalobj);
                                    modalobj.hide();
                                    $('.modal-backdrop').remove();
                                    modal = false;
                                }

                                setContainer(obj.action.refreshhtml);
                                if (typeof dataTable == 'function')
                                    $("#mg-wrapper .datatable").dataTable();
                            }

                            if (typeof obj.action.output.modalhtml != 'undefined') {
                                if (modal) {
                                    modalobj.hide();
                                    $('.modal-backdrop').remove();
                                }

                                //$('[title]').tooltip('hide');
                                setAndOpenModal(obj.action.output.modalhtml);
                            }

                            if (typeof obj.action.output.open_window != 'undefined') {
                                openNewWindow(obj.action.output.open_window);
                            }

                            if (typeof obj.action.output.go_to != 'undefined') {
                                goToPage(obj.action.output.go_to);
                            }

                            if (modal) {
                                if (obj.action.error.length) {
                                    setModalError(obj.action.error, modalobj);
                                } else {
                                    if (typeof do_not_close_the_modal == 'undefined') {
                                        closeModal(modalobj);
                                        setAlerts(obj.action.error, obj.action.info);
                                    }
                                }
                            } else {
                                setAlerts(obj.action.error, obj.action.info);
                            }

                            if (typeof obj.action.output.callback != 'undefined') {
                                if (typeof (window[obj.action.output.callback]) == "function") {
                                    window[obj.action.output.callback](obj.action.output);
                                }
                            }

                            if (typeof rtable != 'undefined' && !obj.action.error.length) {
                                refreshTable(rtable);
                            }

                        } else {
                            alert(obj.errormsg);
                        }
                    } catch (err) {
                        if (modal) {
                            setModalError(getErrorHTML(lang['json_parse_error']), modalobj);
                        } else {
                            setAlerts(getErrorHTML(lang['json_parse_error']), '');
                        }
                        console.log('ERROR: ' + err);
                        console.log(ret);
                    }
                })
                .always(function () {
                    removeLoader(obj);
                    is_ajax_action = false;
                    $('[title]').tooltip('hide').tooltip();
                });
    }
}

function countTableCollumns(table) {
    var colCount = 0;
    $('#' + table + ' tr:nth-child(1) th').each(function () {
        if ($(this).attr('colspan')) {
            colCount += +$(this).attr('colspan');
        } else {
            colCount++;
        }
    });
    return colCount;
}

function refreshTable(table) {
    var colCount = countTableCollumns(table);

    $('#' + table + ' tbody').html('<td colspan="' + colCount + '" class="text-center"><i class="fa fa-spinner fa-pulse"></i></td>');

    var pathArray = queryToArray(location.search.substring(1));
    pathArray['act'] = 'refreshTable';
    pathArray['table'] = table;
    pathArray['ajax'] = 1;
    $.ajax({
        type: "POST",
        url: location.pathname + '?ajax=1',
        data: arrayToQuery(pathArray),
        //async: false
    })
            .done(function (ret) {
                var obj = $.parseJSON(ret);

                if (obj.result == 1) {
                    if (typeof obj.action.output.table != 'undefined') {
                        $('#' + table + ' tbody').replaceWith(obj.action.output.table);
//                $('#' + table + ' th:not(:last-child)').each( function() {
//                    $(this).width($(this).width());
//                });
                        $('[title]').tooltip();
                    }
                }
            });
}

function goToPage(search) {
    location.search = search;
}

function openNewWindow(url) {
    var newwindow = window.open(url, 'vm', 'height=500,width=800');
    if (window.focus) {
        newwindow.focus()
    }
}


function queryToArray(query) {
    var queryParameters = {}, queryString = query, re = /([^&=]+)=([^&]*)/g, m;

    while (m = re.exec(queryString)) {
        if (typeof m[2] == 'string') {
            m[2] = m[2].replace(/\+/g, " ").replace(/%2b/g, '+');
        }
        queryParameters[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
    }
    return queryParameters;
}

function arrayToQuery(array) {
    return $.param(array);
}
