<?php

/* * ********************************************************************
 *  Provisioning Module for NodePing. Custom developed.
 * *
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

if (!defined('DS'))
    define('DS', DIRECTORY_SEPARATOR);

//error_reporting(E_ALL);
//ini_set('display_errors', 1);

defined('WHMCS6') or define('WHMCS6', isset($GLOBALS['CONFIG']['Version']) && (int)$GLOBALS['CONFIG']['Version'] >= '6');
defined('WHMCS7') or define('WHMCS7', isset($GLOBALS['CONFIG']['Version']) && (int)$GLOBALS['CONFIG']['Version'] >= '7');


/**
 * Helper function for including dependent files
 */
function nodePing_loadFiles() {
    require_once(dirname(__FILE__) . DS . "classes" . DS . "class.Product.php");
    require_once(dirname(__FILE__) . DS . "classes" . DS . "class.MG_NodePing_Product.php");
    require_once(dirname(__FILE__) . DS . "classes" . DS . "class.WHMCS_Product.php");
    require_once(dirname(__FILE__) . DS . "classes" . DS . "class.NodePing.php");
    require_once(dirname(__FILE__) . DS . "classes" . DS . "class.NodePing_Curl.php");
    require_once(dirname(__FILE__) . DS . "classes" . DS . "class.NodePing_Helpers.php");

}

function nodePing_loadPlugins($params = []) {
    $plugins = [];
    foreach (new DirectoryIterator(dirname(__FILE__) . DS . "plugins") as $plugin) {
        if($plugin->isDot()) continue;
        require dirname(__FILE__) . DS . "plugins" . DS . $plugin->getFilename() . DS . "config.php";
        require dirname(__FILE__) . DS . "plugins" . DS . $plugin->getFilename() . DS . "language" . DS . "en.php";
        require dirname(__FILE__) . DS . "plugins" . DS . $plugin->getFilename() . DS . "init.php";
    }
    return $plugins;
}


if (function_exists('mysql_safequery') == false) {

    /**
     * Function for SQL queries
     * @param string $query
     * @param array $params
     * @return mysql reqource
     */
    function mysql_safequery($query, $params = false) {
        if ($params) {
            foreach ($params as &$v) {
                $v = mysql_real_escape_string($v);
            }
            $sql_query = vsprintf(str_replace("?", "'%s'", $query), $params);
            $sql_query = mysql_query($sql_query);
        } else {
            $sql_query = mysql_query($query);
        }
        return ($sql_query);

    }

}


// ===================================
// ============= OPTIONS =============
// ===================================

/**
 * Options in product's Module Settings tab
 * @return array
 */
function nodePing_ConfigOptions() {
    nodePing_loadFiles();
    $id      = (int) $_REQUEST['id'];
    $product = new MG_NodePing_Product($id);
    // product configuration only
    if (substr($_SERVER['SCRIPT_FILENAME'], -18) == 'configproducts.php') {
        $product->setupDbTable();
        if ($_REQUEST['action'] != "save") {
            $html =  $product->renderConfigOptions();
            $json = json_encode( ['content' => $html, 'mode' => 'advanced'] );
        }
    }
    if (isset($_REQUEST['error'])) {
        if ($_REQUEST['error'] == "exist") {
            echo '<script type="text/javascript">
                    $(document).ready(function(){
                        $("form[name=\"packagefrm\"]").before("<div class=\"errorbox\"><strong><span class=\"title\">Error!</span></strong><br>Configurable options for this product already exist!</div>");
                    });
                </script>';
        }
    }

    if ($_REQUEST['action'] != "save") {
        if( WHMCS7 ){
            echo $json;
            die();
        }else{
            echo $html;
        }
    }
    return array();

}

/**
 * Helper function for getting product ID
 * @return int|null
 */
function nodePing_getProductID() {
    if (defined("CLIENTAREA") || preg_match('/clientsservices\.php/', $_SERVER['REQUEST_URI'])) {
        $res = mysql_fetch_assoc(mysql_query('SELECT packageid FROM tblhosting WHERE id=' . (int) $_REQUEST['id']));
        return $res['packageid'];
    } elseif (preg_match('/configproducts\.php\?action=edit/', $_SERVER['REQUEST_URI'])) {
        return (int) $_REQUEST['id'];
    }

    return null;

}

/**
 * Helper function for getting config option
 * @param string $optionName
 * @return string|null
 */
function nodePing_getConfigOption($optionName, $productID = NULL) {
    if ($productID == NULL) {
        $config = new MG_NodePing_Product(nodePing_getProductID());
    } else {
        $config = new MG_NodePing_Product($productID);
    }
    $item = $config->getConfig($optionName);
    return $item;

}

// ===================================
// ============= BUTTONS =============
// ===================================

/**
 * Admin button "Create" - create new subaccount in NodePing
 * @param array $params
 * @return string
 */
function nodePing_CreateAccount($params) {
    try{
    nodePing_loadFiles();
    $timezone = nodePing_getConfigOption('nodepingSubAccountTimeZone', $params['pid']);
    $location = nodePing_getConfigOption('nodepingSubAccountLocation', $params['pid']);
    if ($timezone == '' || $location == '') {
        return 'NodePing product is not configured';
    }

    $values = array(
        'name'         => $params['clientsdetails']['firstname'] . ' ' .
        $params['clientsdetails']['lastname'] . ' - ' .
        $params['clientsdetails']['email'],
        'contactname ' => $params['clientsdetails']['firstname'] . ' ' .
        $params['clientsdetails']['lastname'],
        'email'        => $params['clientsdetails']['email'],
        'timezone'     => $timezone,
        'location'     => $location,
        "suppresswelcome" => true
    );
    $nodePing = new NodePing($params['serveraccesshash']);
    $result   = $nodePing->createSubAccount($values);
    if ($result) {
        $result2 = $nodePing->getSubAccountContacts($result->_id);
        if ($result2) {
            $contacts = NodePingHelpers::contactToTable($result2);
            foreach ($contacts as $contact) {
                $result3 = $nodePing->deleteSubAccountContact($result->_id, $contact['id']);
                if ($result3) {
                    mysql_safequery("UPDATE tblhosting SET username =  ? WHERE id = ?", array($result->_id, $params['serviceid']));
                    return 'success';
                } else {
                    $nodePing->deleteSubAccount($result->_id);
                    return $nodePing->getErrorText();
                }
            }
        } else {
            $nodePing->deleteSubAccount($result->_id);
            return $nodePing->getErrorText();
        }
    } else {
        return $nodePing->getErrorText();
    }
    } catch (Exception $e) {
        logModuleCall('nodePing', __FUNCTION__, $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }


}

/**
 * Admin button "Terminate" - delete subaccount in NodePing
 * @param array $params
 * @return string
 */
function nodePing_TerminateAccount($params) {
    nodePing_loadFiles();
    $nodePing = new NodePing($params['serveraccesshash']);
    $result   = $nodePing->deleteSubAccount($params['username']);
    if ($result) {
        mysql_safequery("UPDATE tblhosting SET username =  ? WHERE id = ?", array('', $params['serviceid']));
        return 'success';
    } else {
        return $nodePing->getErrorText();
    }

}

/**
 * Admin button "Suspend" - disable all checks in NodePing subaccount
 * @param array $params
 * @return string
 */
function nodePing_SuspendAccount($params) {
    nodePing_loadFiles();
    $nodePing = new NodePing($params['serveraccesshash']);
    $result   = $nodePing->getSubAccountChecks($params['username']);
    if (!$result) {
        return $nodePing->getErrorText();
    }

    $checks = NodePingHelpers::checksToArray($result);
    foreach ($checks as $check) {
        $values['enabled'] = 'false';
        $result2           = $nodePing->updateSubAccountCheck($params['username'], $check['id'], $values);
        if (!$result) {
            return $nodePing->getErrorText();
        }
    }
    return 'success';

}

/**
 * Admin button "Unsuspend" - enable all checks in NodePing subaccount
 * @param array $params
 * @return string
 */
function nodePing_UnsuspendAccount($params) {
    nodePing_loadFiles();
    $nodePing = new NodePing($params['serveraccesshash']);
    $result   = $nodePing->getSubAccountChecks($params['username']);
    if (!$result) {
        return $nodePing->getErrorText();
    }

    $checks = NodePingHelpers::checksToArray($result);
    foreach ($checks as $check) {
        $values['enabled'] = 'true';
        $result2           = $nodePing->updateSubAccountCheck($params['username'], $check['id'], $values);
        if (!$result2) {
            return $nodePing->getErrorText();
        }
    }
    return 'success';

}

/**
 * Define pages in clientarea
 * @return array
 */
function nodePing_ClientAreaCustomButtonArray() {
    return array(
        'Monitoring Settings' => 'management',
    );

}

/**
 * Smarty variables into Client Area template
 * @return array
 */
function nodePing_ClientArea() {
    nodePing_loadFiles();
    $lang = nodePing_getLang();

//    global $smarty;
    return array(
        'templatefile' => 'clientarea',
        'vars'         => array(
            '_assets_dir' => 'modules/servers/nodePing/assets/',
            'lang'        => $lang['module']
        )
    );

}

/**
 * Main function for clientarea - every page use it. It loads NodePing API, css file, errors to display, mainsite.tpl and additional function.
 * mainsite.tpl loads additional template
 * @param array $params
 */
function nodePing_management($params) {
    // Load plugins
    $plugins = nodePing_loadPlugins($params);
    nodePing_loadFiles();
    $vars['link']     = 'clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&modop=custom&a=management';
    $vars['linkMain'] = 'clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&modop=custom';
    $maindir          = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), 'modules' . DS . 'servers'));
    $params['link']   = $vars['link'];
    $lang             = nodePing_getLang();

    // currently displayed page
    if (empty($_REQUEST['page'])) {
        $page = 'checks';
    } else {
        $page = $_REQUEST['page'];
    }

    $function_name = 'nodePing_' . $page;

    $API = new NodePing($params['serveraccesshash']);

    if ($params['username'] == '') {
        header('Location: ' . $vars['linkMain']);
    }

    if (function_exists($function_name)) {
        $vars_ = call_user_func($function_name, $params, $API, $lang);
        foreach ($vars_ as $k => $v) {
            $vars[$k] = $v;
        }
        $vars['pagefile'] = dirname(__FILE__) . '/templates/' . $page . '.tpl';
    } else {
        $vars['POST']['page_errors'][] = $lang['module']['errNoPage'];
    }

    if (WHMCS6) {
        $vars['WHMCS6'] = true;
    }
    $vars['_assets_dir']   = 'modules/servers/nodePing/assets/';
    $vars['lang']          = $lang;
    $vars['_current_page'] = $page;
    $vars['serviceid']     = $params['serviceid'];


    $vars['product_details'] = mysql_fetch_assoc(mysql_safequery('
        SELECT 
            pg.name as product_group, p.name as product_name, h.id as product_id, h.domain as domain
        FROM 
            tblproductgroups pg
        INNER JOIN
            tblproducts p
        ON
            pg.id=p.gid
        INNER JOIN
            tblhosting h
        ON 
            p.id=h.packageid
        WHERE
            h.id=?
        ', array($params['serviceid'])));

    if (isset($vars['POST']['page_errors'])) {
        $vars['POST']['page_errors'] = array_unique($vars['POST']['page_errors']);
        foreach ($vars['POST']['page_errors'] as $key => $error) {
            if ($error == "") {
                unset($vars['POST']['page_errors'][$key]);
            }
        }
        if (count($vars['POST']['page_errors']) == 0) {
            unset($vars['POST']['page_errors']);
        }
    }

    $vars["plugins"] = $plugins;
    $vars["custom_checks"] = [];
    foreach($plugins as $pluginName => $plugin ){
        if( isset($plugin['module_settings'])){
            $className = ucfirst($pluginName);
            $customChecks = $className::getChecks();
            foreach($vars['checks'] as $k => $v){
                foreach( $customChecks as $cc ){
                    if( $v['id'] == $cc->checkid){
                        $vars['checks'][$k]['type'] = 'Resource Monitor';
                    }
                }
            }
        }
    }
    return array(
        'templatefile' => 'templates/mainsite',
        'breadcrumb'   => ' > <a href="#">' . $lang['module']['emailAccountsManagement'] . '</a>',
        'vars'         => $vars,
    );

}

function nodePing_getAvailableChecks($productID) {
    $product       = new MG_NodePing_Product($productID);
    $configOptions = $product->loadConfig();
    $checks = array();

    foreach ($configOptions as $key => $option) {
        if ($option == 'on') {
            if (strpos($key, 'nodepingCheck') !== false) {
                array_push($checks, str_replace('nodepingCheck', '', $key));
            }
        }
    }
    return $checks;

}

function nodePing_getAvailableNotifications($productID) {
    $product       = new MG_NodePing_Product($productID);
    $configOptions = $product->loadConfig();

    $notifications = array();

    foreach ($configOptions as $key => $option) {
        if ($option == 'on') {
            if (strpos($key, 'nodepingNotification') !== false) {
                array_push($notifications, str_replace('nodepingNotification', '', $key));
            }
        }
    }
    return $notifications;

}

function nodePing_reports( $params, $API, $lang ){
    if (isset($_REQUEST['checkid'])) {
        $POST['checkID'] = $_REQUEST['checkid'];
    } else {
        header('Location: ' . $params['link'] . '&page=checks');
    }
    $POST['span'] = 6;
    if (isset($_REQUEST['span'])) {
        $POST['span'] = (int) $_REQUEST['span'];
        if ($POST['span'] == 0 || $POST['span'] > 720) {
            $POST['span'] = 1;
        }
    }
    $result = $API->getSubAccountCheck($params['username'], $POST['checkID']);
    if ($result) {
        NodePingHelpers::checksToPOST($result, $POST);
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }
    $result = $API->getSubAccountCheckResult($params['username'], $POST['checkID'], $POST['span']);
    if ($result) {
        NodePingHelpers::checkResultToArray($result, $POST);
    } else {
        if (!empty($result)) {
            $POST['page_errors'][] = $API->getErrorText();
        }
    }
    $product       = new MG_NodePing_Product($params["pid"]);
    $configOptions = $product->loadConfig();
    $reportUrl = $configOptions["nodepingReportFQDN"]?$configOptions["nodepingReportFQDN"]:"https://nodeping.com/reports";
    $POST['reports'] = [
       'uptime' => $reportUrl . '/uptime/' . $POST['uuid'],
       'summary' => $reportUrl . '/summary/' . $POST['uuid'] . '/744',
       'results' => $reportUrl . '/results/' . $POST['uuid'] . '/100',
    ];
    return array(
        'POST' => $POST,
        'lang' => $lang,
    );
}

function nodePing_history($params, $API, $lang) {

    if (isset($_REQUEST['checkid'])) {
        $POST['checkID'] = $_REQUEST['checkid'];
    } else {
        header('Location: ' . $params['link'] . '&page=checks');
    }

    $POST['span'] = 6;
    if (isset($_REQUEST['span'])) {
        $POST['span'] = (int) $_REQUEST['span'];
        if ($POST['span'] == 0 || $POST['span'] > 720) {
            $POST['span'] = 1;
        }
    }

    $result = $API->getSubAccountCheck($params['username'], $POST['checkID']);
    if ($result) {
        NodePingHelpers::checksToPOST($result, $POST);
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }

    $result = $API->getSubAccountCheckResult($params['username'], $POST['checkID'], $POST['span']);
    if ($result) {
        NodePingHelpers::checkResultToArray($result, $POST);
    } else {
        if (!empty($result)) {
            $POST['page_errors'][] = $API->getErrorText();
        }
    }

    return array(
        'POST' => $POST,
        'lang' => $lang,
    );

}

function nodePing_check($params, $API, $lang) {

    if( $_POST['type'] == 'RMONITOR' ) {
        $_POST['type'] = 'PUSH';
        $_POST['resourcemonitor'] = true;
    }

    if( isset( $_GET['type']) && ( $_GET['type'] == 'Resource Monitor' ) ){
        $_REQUEST['type'] = 'RMONITOR';
    }
    $POST                          = nodePing_postToSmarty();
    $POST['availableChecks']       = nodePing_getAvailableChecks($params['pid']);
    $POST['minimalCheckFrequency'] = nodePing_getConfigOption('nodepingMinimalCheckFrequency');
    $POST['defaultRunlocations']   = nodePing_getConfigOption('nodepingSubAccountLocation');


    if (!in_array($POST['type'], $POST['availableChecks'])) {
        nodePing_redirect($lang['module']['typeNotAvaliable'], $params['link'], 'checks');
    }

    if (isset($_POST['interval'])) {
        if ($_POST['interval'] < $POST['minimalCheckFrequency']) {
            nodePing_redirect($lang['module']['frequencyUnderLimit'], $params['link'], 'checks');
        }
    }

    $result = $API->getSubAccountContacts($params['username']);
    if ($result) {
        $POST['contactList'] = NodePingHelpers::contactsToArray($result);
        $plugins = nodePing_loadPlugins($params);
        foreach($plugins as $pluginName => $plugin){
            $className = ucfirst($pluginName);
            $POST['contactList'] = $className::filterContactList($POST['contactList']);
        }

    } else {
        $POST['contactList']   = '';
        $POST['page_errors'][] = $API->getErrorText();
    }
    $result = $API->getSubAccountGroups($params['username']);
    if ($result) {
        $POST['groupList'] = NodePingHelpers::groupsToArray($result);
    } else {
        $POST['groupList']     = '';
        $POST['page_errors'][] = $API->getErrorText();
    }

    $result2 = $API->getSubAccountChecks($params['username']);
    if ($result2) {
        $checks = NodePingHelpers::checksToArray($result2);
        foreach ($checks as $key => $check) {
            if ($check['enable'] == 'active') {
                $oneCheckResult = $API->getSubAccountCheckResult($params['username'], $check['id'], 1, 1);
                $status = NodePingHelpers::getLastCheckResultStatus($oneCheckResult);
                $checks[$key]['status'] = $status;
            } else {
                $checks[$key]['status'] = '-';
            }
        }
    }
    switch ($POST['todo']) {
        case 'new':
            if( in_array( $POST['type'], ["HTTPCONTENT","HTTPADV","HTTPPARSE","HTTP"] ) ){
                $POST["param_follow"] = "true";
            }
            break;
        case 'edit':
            if( $POST['type'] == 'Resource Monitor' ){
                $POST['type'] = 'PUSH';
            }
            $result = $API->getSubAccountCheck($params['username'], $POST['checkID']);
            if ($result) {
                $POST['notificationMembers'] = NodePingHelpers::contactsToNotificationsText($result, $POST['contactList'], $POST['groupList']);
                $POST['dep'] = $result->dep;
                NodePingHelpers::checksToPOST($result, $POST);
            } else {
                $POST['page_errors'][] = $API->getErrorText();
            }
            break;
        case 'save':
            $isRmonitor = false;
            if( $POST['type'] == 'RMONITOR' ){
                $POST['type'] = 'PUSH';
                $isRmonitor = true;
            }
            // Fix empty target property validation
            if( isset( $POST['values']['target'] ) && !$POST['values']['target'] ){
                unset($POST['values']['target']);
            }
            // OID and CLUSTER data removal
            if( $POST['type'] == 'CLUSTER' && $POST['checkID']  ){
                $data = (array) $result2->{ $POST['checkID']}->parameters->data;
                foreach( $data as $k => $v ){
                    if( !array_key_exists ( $k, $POST['values']['data'] ) ){
                        $POST['values']['data'][$k] = '';
                    }
                }
            }
            if( ($POST['type'] == 'SNMP' ) || ($POST['type'] == 'PUSH' ) ) {
                if( !$POST['checkID'] ){
                    // Fix fields index values
                    foreach( $POST['values']['fields'] as $k => $field ){
                        $index = 'F' . strtoupper( substr( str_shuffle( str_repeat( 'abcdefghijklmnopqrstuvwxyz0123456789', 10 ) ), 0, 5 ) );
                        $POST['values']['fields'][$index] = $field;
                        unset($POST['values']['fields'][$k]);
                     
                    }
                }else{

                    $POST['values']['data'] = 'remove';
                    $fields = (array) $result2->{ $POST['checkID']}->parameters->fields;
                    foreach ( $fields as $k => $field ){
                        if( !array_key_exists ( $field->name, $POST['values']['fields'] ) ){
                            $POST['values']['fields'][$k] = [ 'remove' => 1 ];
                        }else{
                            $POST['values']['fields'][$k] = $POST['values']['fields'][$field->name];
                            unset( $POST['values']['fields'][$field->name]);
                        }
                    }
                    foreach( $POST['values']['fields'] as $k => $field ){
                        if( !ctype_alnum( $k ) ){
                            $index = 'F' . strtoupper( substr( str_shuffle( str_repeat( 'abcdefghijklmnopqrstuvwxyz0123456789', 10 ) ), 0, 5 ) );
                            $POST['values']['fields'][$index] = $field;
                            unset($POST['values']['fields'][$k]);
                        }
                    }
                }
                
            }
            if ($POST['checkID'] != '') {
                // Process plugins params
                $plugins = nodePing_loadPlugins($params);
                foreach($plugins as $pluginName => $plugin){
                    $className = ucfirst($pluginName);
                    $POST = $className::afterEditCheck($params,$POST,$_REQUEST,$API);
                }
                $result = $API->updateSubAccountCheck($params['username'], $POST['checkID'], $POST['values']);
                if ($result) {
                    nodePing_redirect($lang['module']['checkUpdateSuccess'], $params['link'], 'checks');
                } else {
                    $POST['page_errors'][] = $API->getErrorText();
                }
            } else {
                if (!nodePing_canAddCheck($params, $API, $lang, $POST)) {
                    nodePing_redirect($lang['module']['checkLimit'], $params['link'], 'checks');
                } else {
                    // Process plugins params
                    $plugins = nodePing_loadPlugins($params);
                    foreach($plugins as $pluginName => $plugin){
                        if( isset( $_POST[$plugin["params"]["dependency"]] ) ){
                            $contactsResult = $API->getSubAccountContacts($params['username']);
                            foreach( $plugin["params"]["contacts"] as $contact){
                                // Check if contact already exists
                                $exists = false;
                                foreach($contactsResult as $c){
                                    if($c->name == "eapps"){
                                        $exists = true;
                                    }
                                }
                                if( !$exists ){
                                    $newAddress = [];
                                    $newAddress[] = array('address' => $contact["email"], 'type' => "email");
                                    $newAddress[] = array('address' => $contact["slack"], 'type' => "slack");
                                    $result = $API->addSubAccountContact($params["username"], "eapps", "notify", $newAddress);
                                }
                                foreach($contactsResult as $c){
                                    if($c->name == "eapps"){
                                        foreach( $c->addresses as $k => $a ){
                                            $POST["notificationMembers"][] = [
                                                "text" => "{$c->name} - {$a->type} - {$a->address}",
                                                "id" => $k,
                                                "time" => "All"
                                            ];
                                            $POST["values"]["notifications"][] = [
                                                $k => [
                                                    'schedule' => "All"
                                                ]
                                            ];
                                        }
                                    }
                                }

                            }
                        }
                    }
                    if( $isRmonitor ){
                        $template = nodePing_getConfigOption('RESOURCEMONITORTEMPLATE');
                        $parentChecks  = $API->getChecks();
                        foreach( $parentChecks as $k => $parentCheck ){
                            if ($k == $template){
                                $POST['values']['runlocations'] = $parentCheck->runlocations[0];
                                $POST['values']['interval'] = $parentCheck->interval;
                                $POST['values']['threshold'] = $parentCheck->parameters->threshold;
                                $POST['values']['sens'] = $parentCheck->parameters->sens;
                                foreach( $parentCheck->parameters->fields as $pk => $pv ){
                                    $POST['values']['fields'][$pk] = [
                                        'name' => $pv->name,
                                        'min' => $pv->min,
                                        'max' => $pv->max
                                    ];
                                }
                            }
                        }
                    }
                    $result = $API->addSubAccountCheck($params['username'], $POST['values']);
                    if ($result) {
                        $plugins = nodePing_loadPlugins();
                        foreach($plugins as $pluginName => $plugin){
                            $className = ucfirst($pluginName);
                            $className::afterCreateCheck($params,$result->_id);
                        }
                        nodePing_redirect($lang['module']['checkAddSuccess'], $params['link'], 'checks');
                    } else {
                        $POST['page_errors'][] = $API->getErrorText();
                    }
                }
            }
            break;
        default:
            nodePing_redirect($lang['module']['actionNotAllowed'], $params['link'], 'checks');
            break;
    }
    return array(
        'POST'        => $POST,
        'lang'        => $lang,
        'currentType' => $POST['type'],
        'checks' => $checks
    );

}

function nodePing_checks($params, $API, $lang) {
    $POST            = nodePing_postToSmarty();
    $availableChecks = nodePing_getAvailableChecks($params['pid']);
    $checks          = array();
    $plugins = nodePing_loadPlugins($params);
    if (isset($availableChecks[0])) {
        $POST['newCheck'] = $availableChecks[0];
    }

    if (isset($_REQUEST['todo'], $_REQUEST['checkid'])) {
        $result = $API->deleteSubAccountCheck($params['username'], $POST['checkID']);
        if ($result) {
            sleep(2);
            foreach($plugins as $pluginName => $plugin){
                $className = ucfirst($pluginName);
                $className::afterDeleteCheck($params,$POST['checkID']);
            }
            nodePing_redirect($lang['module']['checkDeleteSuccess'], $params['link'], 'checks');
        } else {
            $POST['page_errors'][] = $API->getErrorText();
        }
    }

    nodePing_canAddCheck($params, $API, $lang, $POST);

    $result2 = $API->getSubAccountChecks($params['username']);
    if ($result2) {
        $checks = NodePingHelpers::checksToArray($result2);
        if (isset($params['configoptions']['nodePingChecks'])) {
            $checksLimit  = $params['configoptions']['nodePingChecks'];
        } else {
            $checksLimit = 0;
        }
        foreach($plugins as $pluginName => $plugin){
            if( $plugin['params']['dependency'] ){
                $className = ucfirst($pluginName);
                $freeMonitors = $className::getFreeMonitors($params);
                $checksLimit += $freeMonitors;
            }
        }

        if( count($checks) > $checksLimit ){
             $checks = array_slice( $checks, 0, $checksLimit);
        }
        foreach ($checks as $key => $check) {
            if ($check['enable'] == 'active') {
                $oneCheckResult         = $API->getSubAccountCheckResult($params['username'], $check['id'], 1, 1);
                $status                 = NodePingHelpers::getLastCheckResultStatus($oneCheckResult);
                $checks[$key]['status'] = $status;
            } else {
                $checks[$key]['status'] = '-';
            }
        }
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }
    $responders = [];
    foreach($plugins as $pluginName => $plugin){
        if( $plugin['params']['dependency'] ){
            $className = ucfirst($pluginName);
            $responders = $className::getResponderList();
        }
    }
    return array(
        'POST'   => $POST,
        'lang'   => $lang,
        'checks' => $checks,
        "responders" => $responders
    );

}

function nodePing_canAddCheck($params, $API, $lang, &$POST) {

    if (isset($params['configoptions']['nodePingChecks'])) {
        $POST['checksLimit'] = $params['configoptions']['nodePingChecks'];
    } else {
        $POST['checksLimit'] = 0;
    }

    $POST['checksCount'] = 0;

    $result = $API->getSubAccountChecks($params['username']);
    if ($result) {
        $checks              = NodePingHelpers::checksToArray($result);
        $POST['checksCount'] = count($checks);
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }

    if ($POST['checksLimit'] == 0) {
        $POST['checksPercentage'] = 100;
    } else {
        $POST['checksPercentage'] = round(($POST['checksCount'] / $POST['checksLimit']) * 100);
    }



    $plugins = nodePing_loadPlugins($params);
    foreach($plugins as $pluginName => $plugin){
        if( $plugin['params']['dependency'] ){
            $className = ucfirst($pluginName);
            $freeMonitors = $className::getFreeMonitors($params);
            $POST['checksLimit'] += $freeMonitors;
        }
    }
    if ($POST['checksCount'] < $POST['checksLimit']) {
        $POST['checksCanAdd'] = TRUE;
        return TRUE;
    } else {
        $POST['checksCanAdd'] = FALSE;
        return FALSE;
    }

}

function nodePing_contact($params, $API, $lang) {

    $POST                           = nodePing_postToSmarty();
    $POST['availableNotifications'] = nodePing_getAvailableNotifications($params['pid']);

    switch ($POST['todo']) {
        case 'new':
            break;
        case 'edit':
            $result = $API->getSubAccountContact($params['username'], $POST['contactID']);
            if ($result) {
                NodePingHelpers::groupsToPOST($result, $POST);
            } else {
                $POST['page_errors'][] = $API->getErrorText();
            }
            break;

        case 'save':
            $plugins = nodePing_loadPlugins($params);
            foreach($plugins as $pluginName => $plugin){
                $className = ucfirst($pluginName);
                $contactsFiltered = $className::filterContactList($POST['contacts']);
                if( count(  $POST['contacts'] ) > count( $contactsFiltered ) ){
                    $POST['page_errors'][] = $plugin["lang"]["contacts"]["error"];
                    return array(
                        'POST' => $POST,
                        'lang' => $lang,
                    );
                }
            }

            if ($POST['contactID'] != '') {

                $result = $API->updateSubAccountContact(
                        $params['username'], $POST['contactID'], $POST['contactName'], $POST['contactLevel'], $POST['oldAddress'], $POST['newAddress']);
                if ($result) {
                    nodePing_redirect($lang['module']['contactUpdateSuccess'], $params['link'], 'contacts');
                } else {
                    $POST['page_errors'][] = $API->getErrorText();
                }
            } else {
                if (!nodePing_canAddContact($params, $API, $lang, $POST)) {
                    nodePing_redirect($lang['module']['contactLimit'], $params['link'], 'contacts');
                }
                $newAddress = array();

                foreach ($POST['contacts'] as $contact) {
                    if ($contact['id'] == '') {
                        $newAddress[] = array('address' => $contact['value'], 'type' => $contact['type']);
                    }
                }
                $result = $API->addSubAccountContact($params['username'], $POST['contactName'], $POST['contactLevel'], $newAddress);
                if ($result) {
                    nodePing_redirect($lang['module']['contactAddSuccess'], $params['link'], 'contacts');
                } else {
                    $POST['page_errors'][] = $API->getErrorText();
                }
            }
            break;
        default:
            nodePing_redirect($lang['module']['actionNotAllowed'], $params['link'], 'contacts');
            break;
    }

    return array(
        'POST' => $POST,
        'lang' => $lang,
    );

}

function nodePing_contacts($params, $API, $lang) {
    $POST     = nodePing_postToSmarty();
    $contacts = array();
    nodePing_canAddContact($params, $API, $lang, $POST);
    $nodePing = new NodePing($params['serveraccesshash']);
    if( isset($_REQUEST['timezone'] )){
        $nodePing->updateSubAccount($params['username'], ['timezone' => $_REQUEST['timezone']]);
    }

    $account = $nodePing->getSubAccountInfo($params['username']);
    $POST['timezone'] = $account->timezone;
    if (isset($_REQUEST['todo'], $_REQUEST['contactid'])) {
        $contactID = $_REQUEST['contactid'] . '';
        $result    = $nodePing->deleteSubAccountContact($params['username'], $contactID);
        if ($result) {
            nodePing_redirect($lang['module']['contactDeleteSuccess'], $params['link'], 'contacts');
        } else {
            $POST['page_errors'][] = $API->getErrorText();
        }
    }

    $result = $nodePing->getSubAccountContacts($params['username']);

    if ($result) {
        $contacts = NodePingHelpers::contactToTable($result);
        $plugins = nodePing_loadPlugins($params);
        foreach($plugins as $pluginName => $plugin){
            $className = ucfirst($pluginName);
            $contacts = $className::filterContactList($contacts);
        }
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }

    return array(
        'POST'     => $POST,
        'lang'     => $lang,
        'contacts' => $contacts,
    );

}

function nodePing_canAddContact($params, $API, $lang, &$POST) {

    if (isset($params['configoptions']['nodePingContacts'])) {
        $POST['contactLimit'] = $params['configoptions']['nodePingContacts'];
    } else {
        $POST['contactLimit'] = 0;
    }

    $POST['contactCount'] = 0;

    $result = $API->getSubAccountContacts($params['username']);
    if ($result) {
        $POST['contactCount'] = NodePingHelpers::getContactsCount($result);
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }

    if ($POST['contactLimit'] == 0) {
        $POST['contactPercentage'] = 100;
    } else {
        $POST['contactPercentage'] = round(($POST['contactCount'] / $POST['contactLimit']) * 100);
    }

    if ($POST['contactCount'] < $POST['contactLimit']) {
        $POST['contactCanAdd'] = TRUE;
        return TRUE;
    } else {
        $POST['contactCanAdd'] = FALSE;
        return FALSE;
    }

}

function nodePing_group($params, $API, $lang) {

    $POST = nodePing_postToSmarty();

    $result = $API->getSubAccountContacts($params['username']);
    if ($result) {
        $POST['contactList'] = NodePingHelpers::contactsToArray($result);
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }
    $plugins = nodePing_loadPlugins($params);
    foreach($plugins as $pluginName => $plugin){
        $className = ucfirst($pluginName);
        $POST['contactList'] = $className::filterContactList($POST['contactList']);
    }


    switch ($POST['todo']) {
        case 'new':
            break;
        case 'edit':
            $result = $API->getSubAccountGroup($params['username'], $POST['groupID']);
            if ($result) {
                $POST['groupMembers'] = NodePingHelpers::contactsToMembersText($result, $POST['contactList']);
                $POST['groupName']    = NodePingHelpers::groupName($result);
            } else {
                $POST['page_errors'][] = $API->getErrorText();
            }
            break;
        case 'save':
            if ($POST['groupID'] != '') {
                $members = array();
                foreach ($POST['groupMembers'] as $groupMember) {
                    $members[] = $groupMember['id'];
                }
                $result = $API->updateSubAccountGroup(
                        $params['username'], $POST['groupID'], $POST['groupName'], $members);
                if ($result) {
                    nodePing_redirect($lang['module']['groupUpdateSuccess'], $params['link'], 'groups');
                } else {
                    $POST['page_errors'][] = $API->getErrorText();
                }
            } else {
                $members = array();
                foreach ($POST['groupMembers'] as $groupMember) {
                    $members[] = $groupMember['id'];
                }
                $result = $API->updateSubAccountGroup(
                        $params['username'], $POST['groupID'], $POST['groupName'], $members);
                if ($result) {
                    nodePing_redirect($lang['module']['groupAddSuccess'], $params['link'], 'groups');
                } else {
                    $POST['page_errors'][] = $API->getErrorText();
                }
            }
            break;
        default:
            nodePing_redirect($lang['module']['actionNotAllowed'], $params['link'], 'groups');
            break;
    }

    return array(
        'POST' => $POST,
        'lang' => $lang,
    );

}

function nodePing_groups($params, $API, $lang) {

    $POST   = nodePing_postToSmarty();
    $groups = array();

    if (isset($_REQUEST['todo'], $_REQUEST['groupid'])) {
        $result = $API->deleteSubAccountGroup($params['username'], $POST['groupID']);
        if ($result) {
            nodePing_redirect($lang['module']['groupDeleteSuccess'], $params['link'], 'groups');
        } else {
            $POST['page_errors'][] = $API->getErrorText();
        }
    }

    $result = $API->getSubAccountGroups($params['username']);
    if ($result) {
        $groups = NodePingHelpers::groupsToArray($result);
    } else {
        $POST['page_errors'][] = $API->getErrorText();
    }

    return array(
        'POST'   => $POST,
        'lang'   => $lang,
        'gropus' => $groups,
    );

}

function nodePing_postToSmarty() {
    if (isset($_SESSION['nodePingInfo'])) {
        $POST['infos'][] = $_SESSION['nodePingInfo'];
        unset($_SESSION['nodePingInfo']);
    }
    $fieldsNames = array(
        'type', 'label', 'enabled', 'description', 'public',
        'runlocations', 'interval', 'param_target', 'param_port',
        'param_dnstype', 'param_dnstoresolve', 'param_contentstring',
        'param_username', 'param_password', 'param_follow',
        'param_statuscode', 'param_method', 'param_invert', 'param_email',
        'param_secure', 'param_verify', 'param_warningdays', 'param_postdata',
        'param_ignore', 'param_data', 'param_threshold', 'param_sens','param_ipv6',
        'param_snmpv','param_snmpcom','delay','param_dep','param_whoisserver',
        'param_transport','param_ipv6','param_checktoken'
    );
    
    foreach ($fieldsNames as $field) {
        if (isset($_POST[$field])) {
            $POST[$field] = html_entity_decode($_POST[$field]);
        } elseif (isset($_REQUEST[$field])) {
            $POST[$field] = html_entity_decode($_REQUEST[$field]);
        }
    }
    foreach ($fieldsNames as $field) {
        $tempName = str_replace('param_', '', $field);

        if (isset($_POST[$field])) {
            $POST['values'][$tempName] = html_entity_decode($_POST[$field]);
        } else {
            $POST['values'][$tempName] = '';
        }
    }

    if (isset($_POST['requestHeader'])) {
        foreach ($_POST['requestHeader'] as $key => $value) {
            $POST['values']['sendheaders'][$value] = $_POST['requestValue'][$key];
        }
    } else {
        $POST['values']['sendheaders'] = '';
    }

    if (isset($_POST['responseHeader'])) {
        foreach ($_POST['responseHeader'] as $key => $value) {
            $POST['values']['receiveheaders'][$value] = $_POST['responseValue'][$key];
        }
    } else {
        $POST['values']['receiveheaders'] = '';
    }

    if (isset($_POST['postfieldsField'])) {
        foreach ($_POST['postfieldsField'] as $key => $value) {
            $POST['values']['data'][$value] = $_POST['postfieldsValue'][$key];
        }
    } else {
        $POST['values']['data'] = '';
    }

    if (!isset($_POST['param_postdata'])) {
        $POST['values']['postdata'] = '';
    }

    if (isset($_POST['fieldsName'])) {
        foreach ($_POST['fieldsName'] as $key => $value) {
            $POST['values']['fields'][$value] = array(
                'name' => $_POST['fieldsName'][$key],
                'min'  => $_POST['fieldsMin'][$key],
                'max'  => $_POST['fieldsMax'][$key]);
        }
    } else {
        $POST['values']['fields'] = array();
    }
    if (isset($_POST['notyficationId'])) {
        foreach ($_POST['notyficationId'] as $key => $value) {
            $notification = [ $value => ['schedule' => $_POST['notyficationTime'][$key] ]  ];
            if( $_POST['notyficationDelay'][$key] ){
                $notification[$value]['delay'] =  $_POST['notyficationDelay'][$key];   
            }
            $POST['values']['notifications'][] = $notification;
        }
    } else {
        $POST['values']['notifications'][] = '';
    }
    if (!isset($_POST['public'])) {
        $POST['values']['public'] = 'false';
    }

    if (!isset($_POST['enabled'])) {
        $POST['values']['enabled'] = 'false';
    }

    if (isset($_POST['contactValue'])) {
        foreach ($_POST['contactValue'] as $key => $value) {
            $POST['contacts'][] = array(
                'value' => $_POST['contactValue'][$key],
                'type'  => $_POST['contactType'][$key],
                'id'    => $_POST['contactID'][$key]
            );
        }
    } else {
        $POST['contacts'] = array();
    }

    if (isset($_POST['contactName'])) {
        $POST['contactName'] = $_POST['contactName'];
    } else {
        $POST['contactName'] = '';
    }

    if (isset($_POST['contactLevel'])) {
        $POST['contactLevel'] = 'notify';
    } else {
        $POST['contactLevel'] = 'notify';
    }

    if (isset($_REQUEST['contactid'])) {
        $POST['contactID'] = $_REQUEST['contactid'];
    } else {
        $POST['contactID'] = '';
    }


    $POST['newAddress'] = array();
    $POST['oldAddress'] = array();


    foreach ($POST['contacts'] as $contact) {
        if ($contact['id'] == '') {
            $POST['newAddress'] [] = array('address' => $contact['value'], 'type' => $contact['type']);
        }
    }

    foreach ($POST['contacts'] as $contact) {
        if ($contact['id'] != '') {
            $POST['oldAddress'][$contact['id']] = array('address' => $contact['value'], 'type' => $contact['type']);
        }
    }

    if (isset($_REQUEST['todo'])) {
        $POST['todo'] = $_REQUEST['todo'];
    }

    if (isset($_REQUEST['type'])) {
        $POST['type'] = $_REQUEST['type'];
    }

    if (!isset($POST['type'])) {
        $POST['type'] = '';
    }


    if (isset($_REQUEST['checkid'])) {
        $POST['checkID'] = $_REQUEST['checkid'];
    } else {
        $POST['checkID'] = '';
    }

    if (isset($_REQUEST['groupid'])) {
        $POST['groupID'] = $_REQUEST['groupid'];
    } else {
        $POST['groupID'] = '';
    }

    if (isset($_POST['groupName'])) {
        $POST['groupName'] = $_POST['groupName'];
    } else {
        $POST['groupName'] = '';
    }

    if (isset($_POST['memberId'])) {
        foreach ($_POST['memberId'] as $key => $value) {
            $POST['groupMembers'][] = array(
                'text' => $_POST['memberName'][$key],
                'id'   => $_POST['memberId'][$key]
            );
        }
    }

    if (isset($_POST['notyficationId'])) {
        foreach ($_POST['notyficationId'] as $key => $value) {
            $POST['notificationMembers'][] = array(
                'text' => $_POST['notyficationName'][$key],
                'id'   => $_POST['notyficationId'][$key],
                'time' => $_POST['notyficationTime'][$key]
            );
        }
    }


    return $POST;

}

/**
 * Helper function for language array
 * @return array
 */
function nodePing_getLang() {

    $maindir      = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), 'modules' . DS . 'servers'));
    $language_dir = $maindir . 'modules' . DS . 'servers' . DS . 'nodePing' . DS . 'lang' . DS;

    $language     = !$_SESSION['Language'] || !file_exists($language_dir . $_SESSION['Language'] . '.php') ? 'english' : $_SESSION['Language'];
    $langFilePath = $language_dir . $language . '.php';
    if (file_exists($langFilePath)) {
        require_once( $langFilePath);
        return $lang;
    } else {
        die('Failed load language file.');
    }

}

function nodePing_redirect($infoMessage, $link, $page) {
    $_SESSION['nodePingInfo'] = $infoMessage;
    ob_clean();
    header('Location: ' . $link . '&page=' . $page);
    exit();

}

function nodePing_ChangePackage($params){
    try{
        nodePing_loadFiles();
        $API = new NodePing($params['serveraccesshash']);
        $POST            = nodePing_postToSmarty();
        $checks = $API->getSubAccountChecks($params['username']);
        if ($checks) {
            $checks = NodePingHelpers::checksToArray($checks);
            if (isset($params['configoptions']['nodePingChecks'])) {
                $checksLimit  = $params['configoptions']['nodePingChecks'];
            } else {
               $checksLimit = 0;
            }

            if( count($checks) > $checksLimit ){
                // Disable checks
                $checksToDisable = array_slice( $checks,( count($checks) - ( count($checks) - $checksLimit) ));
                $values = [];
                $values['enabled'] = 'false';
                foreach( $checksToDisable as $check ){
                    $API->updateSubAccountCheck($params['username'], $check['id'], $values);
                }
            }
 
            $plugins = nodePing_loadPlugins($params);
            foreach($plugins as $pluginName => $plugin){
                $className = ucfirst($pluginName);
                $className::afterChangePackage($params);
            }
        }
        return 'success';

    }catch(Exception $e){
    }
}
